## xmhtml 1.1.10

=== Makefile ===
##############################################################################
#                                                                            #
# Makefile.org: default XmHTML makefile.                                     #
# Adjust at will                                                             #
#                                                                            #
##############################################################################
#                                                                            #
# (C)Copyright 1995-1997 Ripley Software Development                         #
# All Rights Reserved                                                        #
#                                                                            #
# This file is part of the XmHTML Widget Library.                            #
#                                                                            #
# This library is free software; you can redistribute it and/or              #
# modify it under the terms of the GNU Library General Public                #
# License as published by the Free Software Foundation; either               #
# version 2 of the License, or (at your option) any later version.           #
#                                                                            #
# This library is distributed in the hope that it will be useful,            #
# but WITHOUT ANY WARRANTY; without even the implied warranty of             #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          #
# Library General Public License for more details.                           #
#                                                                            #
# You should have received a copy of the GNU Library General Public          #
# License along with this library; if not, write to the Free                 #
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         #
##############################################################################
#
# The defaults in this Makefile are for Linux.

# Don't change these numbers! (only exception: the maintainer of the library if making a new release)
VERSION = 1110
ARCHIVE = 1.1.10
#The SONAME has to be increased when incompatible changes are made to the API.
#The Versionnumber ( in variables VERSION and ARCHIVE above ) has to start with the SONAME.
SONAME= libXmHTML.so.1.1

# OS platform
# OS=Linux
# OS=IRIX

# Target toolkit
# Possible choices: Motif, gtk
# Both targets might require you to adjust the LIBS and LIBDIR directives.
TOOLKIT=Motif

# XFT-Support?
ifeq ($(OS),IRIX)
HAVE_XFT=0
else
HAVE_XFT=1
endif

# XPM-Support
# If you switch that off, you'll have no builtin icons
HAVE_XPM=1

# Directories in which to build. If you don't want the examples build,
# remove the examples directory from this line.
# If you want to build the XmHTML tutorial examples, add the book directory.

ifeq ($(OS),IRIX)
SUBDIRS= lib http
else
SUBDIRS= lib http examples tools
endif

# some common definitions
#
CP    = cp
RM    = rm -f
MV    = mv
LN    = ln -sf

# for building the library. 
AR    = ar cq 
# replace with echo or /bin/true if you system doesn't have/need ranlib
ifeq ($(OS),IRIX)
RANLIB = /bin/true
else
RANLIB = ranlib
endif

SHELL = /bin/sh
MAKE  = make 
# change this to makedepend if your system doesn't have gcc
MAKEDEPEND= gccmakedep


#####################
# OS-Specific compiler flags
#####################

ifeq ($(OS),IRIX)
OS_CFLAGS	= -O2 -DIRIX_65
endif

#####################
#                   #
# Compiler Settings #
#                   #
#####################
CC       	= gcc
CFLAGS   	= -funroll-loops -Wall -pipe -ansi -fPIC $(OS_CFLAGS) $(EXTRA_CFLAGS)
LDFLAGS  	= 

# The following flags are *very* usefull if you are getting unresolved
# references to functions in libraries that you *know* to exist.
# When used, they cause ld to list its search for libraries, the object
# files it is considering for linking and a bunch of other information.
# It helped me to track down an incorrect version of libz that was
# lingering around in a directory where I never expected it to be.
# Note: these flags are for gcc!
# LDFLAGS  = -Wl,-t -Wl,--verbose

# Image Support
# XPM images (libXpm)                          => -DHAVE_XPM
# JPEG images (jpeglib.h and libjpeg)          => -DHAVE_LIBJPEG
# PNG images  (png.h, zlib.h, libz and libpng) => -DHAVE_LIBPNG
# GZF images  (zlib.h and libz)                => -DHAVE_LIBZ or -DHAVE_LIBPNG
#
#
#
# You can configure the Progressive Image Loading to use either timeouts or
# work procedures. The default is to use timeouts (XmHTML will cycle through
# each image that is to be loaded progressively using a dynamically computed
# polling interval). If you want XmHTML to use work procedures, you need to 
# define PLC_WORKPROCS
# The differences between the two methods are:
# timeouts:  XmHTML is quite responsive to user-input, image loading not
#            really fast (but neither really slow). Polling interval is
#            computed dynamically depending on the state of each PLC (suspended
#            versus active); 
# workprocs: XmHTML not really responsive, image loading quite fast.
#
# Dithering: there are two algorithms available that allow XmHTML to construct
# a default palette if none has been specified.
# default: the default algorithm constructs an evenly distributed palette in
#          RGB space but is not always able to match the requested number of
#          colors and requires a minumum of 8 colors.
# simple:  this is the alternative, which always creates a palette with the
#          requested number of colors but does not always succeed in creating
#          an evenly distributed palette. It is selected by defining
#          DITHER_SIMPLE_COLORMAP.

IMAGEDEFINES = -DHAVE_LIBJPEG -DHAVE_LIBPNG

ifeq ($(HAVE_XPM),1)
IMAGEDEFINES += -DHAVE_XPM
endif

ifeq ($(HAVE_XFT),1)
XFT_DEFINES = -DHAVE_XFT
endif

# Header file locations. Add path to xpm.h if it isn't in the X11 include
# directory. Depending on the selected image support, the compiler needs to
# be able to find the following header files:
# HAVE_LIBJPEG => jpeglib.h
# HAVE_LIBPNG  => png.h and zlib.h
# HAVE_LIBZ => zlib.h

ZLIBINC       =
IMAGEINCLUDES = $(ZLIBINC)

# Image libraries
# No need to add -lXpm if you need to include it with LIBS below
# Depending on selected image support your linker needs to find the following
# libraries:
# HAVE_LIBJPEG => libjpeg
# HAVE_LIBPNG  => libpng and libz (and possibly libm)
# HAVE_LIBZ => libz (and possibly libm)

ZLIBLIB   = -lz -lm
IMAGELIBS = -ljpeg -lpng $(ZLIBLIB)

# It might be troublesome to know what the correct defines are for your
# system. A possible set of defines for some OS's is given below. Pick
# your choice.
#
# HPUX:
# 	-D_HPUX_SOURCE -D_POSIX_SOURCE
#
# Linux:
#	-D_BSD_SOURCE -D_GNU_SOURCE -D_POSIX_SOURCE -DHAVE_REGEX_H
#
# AIX 4.1.5:
#	-DHAVE_STRINGS_H -DHAVE_REGEX_H
#
#	(AIX 4.1.5 has str[n]casecmp, but it's defined in strings.h)
#
# Unixware 1.1.2
#	-DNEED_STRCASECMP -DNEED_STRERROR -DSVR4 -DHAVE_MEMCPY
#
# Unixware 2.1.1
#	-DNEED_STRCASECMP -D_POSIX_SOURCE
#
# LynxOS
#	-DNEED_STRCASECMP
#
# SCO 3.2
#	-DNEED_STRCASECMP -D_POSIX_SOURCE
#
# If you have dmalloc, you might wish to add -DDMALLOC
#
# If your system does not have str[n]casecmp, add -DNEED_STRCASECMP (unixware)
# If your system does not have strerror, add -DNEED_STRERROR
# If your system has POSIX regex.h, add -DHAVE_REGEX_H
#
# Add -DI18N for internationalization and multilingual support.
# Add -DPEDANTIC to get warnings about bad html and unsupported features.
# Add -DDEBUG to enable selective debug output (see the file DEBUGGING for more
# info).
#
CPPFLAGS = -D_GNU_SOURCE -D_BSD_SOURCE -D_POSIX_SOURCE -DHAVE_REGEX_H \
	$(EXTRA_CPPFLAGS) \
	$(IMAGEDEFINES) \
	$(XFT_DEFINES)

# Various include directories
LIBINC=-I. -I../include -I../include/common -I../../include -I../../include/common

# Toolkit specific includes
ifeq ($(TOOLKIT),Motif)
ifeq ($(OS),IRIX)
TOOLKITINC=-I../../include/XmHTML -I/usr/include
else
TOOLKITINC=-I../../include/XmHTML -I/usr/X11R6/include -I/usr/include/freetype2
endif
else
ifeq ($(TOOLKIT),gtk)
TOOLKITINC=\
	-I../../include/gtk-xmhtml -I/usr/local/include -I/usr/include/freetype2 \
	-I/usr/include/gtk-2.0 -I/usr/include/glib-2.0 -I/usr/lib/glib-2.0/include \
	-I/usr/include/cairo -I/usr/include/pango-1.0 \
	-I/usr/lib/gtk-2.0/include -I/usr/include/gdk-pixbuf-2.0 -I/usr/include/atk-1.0
endif
endif

# include directories
# If using dmalloc, add the path where the dmalloc.h include file can be 
# found. On my system it's in /usr/local/include
INCLUDES = $(LIBINC) $(TOOLKITINC) $(IMAGEINCLUDES) $(EXTRA_INCLUDES)

# linker flags
# Uncomment if you're building libXmHTML with dmalloc support
# DMALLOCLIB = -ldmalloc

# Motif version (default)
ifeq ($(TOOLKIT),Motif)
ifeq ($(OS),IRIX)
LIBDIR = -L/usr/lib32
else
LIBDIR = -L/usr/X11R6/lib
endif
# This is what is required under Linux (Motif 2.0.1).
# Your mileage may vary.
LIBS   = -lXm -lXmu -lXt -lXext -lX11 -lSM -lICE

else

# gtk version (only supported port for now)
ifeq ($(TOOLKIT),gtk)

LIBDIR = -L/usr/local/lib -L
LIBS   = -lgdk-x11-2.0 -lgtk-x11 -lX11

# endif gtk
endif
endif

ifeq ($(HAVE_XPM),1)
LIBS += -lXpm
endif

ifeq ($(HAVE_XFT),1)
LIBS += -lXft -lfontconfig
endif

# Uncomment if you're building libXmHTML with dmalloc support
# DMALLOCLIB = -ldmalloc

# final line fed to the linker 
LOADLIBES = $(LIBDIR) $(LIBS) $(IMAGELIBS)

### End of User configurable section ###

pass_flags = SHELL='$(SHELL)' \
	VERSION='$(VERSION)' \
	ARCHIVE='$(ARCHIVE)' \
	SONAME='$(SONAME)' \
	CC='$(CC)' \
	RM='$(RM)' \
	AR='$(AR)' \
	MV='$(MV)' \
	CP='$(CP)' \
	LN='$(LN)' \
	RANLIB='$(RANLIB)' \
	MAKEDEPEND='$(MAKEDEPEND)' \
	CFLAGS='$(CFLAGS)' \
	LDFLAGS='$(LDFLAGS)' \
	CPPFLAGS='$(CPPFLAGS) -D$(TOOLKIT)' \
	INCLUDES='$(INCLUDES)' \
	LOADLIBES='$(LOADLIBES)' \
	DMALLOCLIB='$(DMALLOCLIB)' \
	ZLIBLIB='$(ZLIBLIB)' \
	TOOLKIT='$(TOOLKIT)'

all::
	@( for dir in $(SUBDIRS) ; do \
		(set -x ; cd $$dir ; $(MAKE) all $(pass_flags) ) ; \
	done)

# Separate rules for all targets 
lib::
	@(set -x; cd lib; $(MAKE) all $(pass_flags) )

http::
	@(set -x; cd http; $(MAKE) all $(pass_flags) )

examples::
	@(set -x; cd lib; $(MAKE) all $(pass_flags) )
	@(set -x; cd http; $(MAKE) all $(pass_flags) )
	@(set -x; cd examples; $(MAKE) all $(pass_flags) )

tools::
	@(set -x; cd http; $(MAKE) all $(pass_flags) )
	@(set -x; cd tools; $(MAKE) all $(pass_flags) )

contrib::
	@(set -x; cd lib; $(MAKE) all $(pass_flags) )
	@(set -x; cd contrib; $(MAKE) all $(pass_flags) )

book::
	@(set -x; cd lib; $(MAKE) all $(pass_flags) )
	@(set -x; cd book; $(MAKE) all $(pass_flags) )

# Global target for building everything
World::
	$(MAKE) clean
	$(MAKE) includes
	$(MAKE) depend
	$(MAKE) lib
	$(MAKE) http
	$(MAKE) examples
	$(MAKE) tools
	$(MAKE) book

# Global target for building everything with Imake
#imake::
#	xmkmf
#	$(MAKE) World

depend:: 
	@( for dir in $(SUBDIRS) ; do \
		(set -x ; cd $$dir ; $(MAKE) depend $(pass_flags)) ; \
	done)

clean:: 
	@( for dir in $(SUBDIRS) ; do \
		(set -x ; cd $$dir ; $(MAKE) clean $(pass_flags) ) ; \
	done)

distclean:: 
	@( for dir in $(SUBDIRS) ; do \
		(set -x ; cd $$dir ; $(MAKE) distclean $(pass_flags) ) ; \
	done)
	@(set -x; cd book; $(MAKE) distclean $(pass_flags) )
	@(set -x; cd contrib; $(MAKE) distclean $(pass_flags) )
	$(RM) docs/sources.desc
	$(RM) core *.out *.log make.world *.bak *.last *.auto *.rej *.orig
	#$(CP) Makefile.org Makefile

dist:: distclean
	$(LN) . XmHTML-$(ARCHIVE)
	tar cvf - XmHTML-$(ARCHIVE)/* | gzip -c > XmHTML-$(ARCHIVE).tar.gz

docs::
	tools/scansrc.sh ./lib/common > docs/sources.desc
	tools/scansrc.sh ./lib/Motif >> docs/sources.desc
	tools/scansrc.sh ./lib/gtk >> docs/sources.desc

=== book/Makefile ===

# List of sources
SRCS = simple_html.c simple_html2.c autosize_html.c forced_html.c html.c \
	html_browser.c

# List of object files
OBJS = simple_html.o simple_html2.o autosize_html.o forced_html.o html.o \
	html_browser.o

# Targets to make
EXAMPLES=simple_html simple_html2 autosize_html forced_html html html_browser

# The library
XMHTMLINC= -I../lib
XMHTMLLIB= -L../lib -lXmHTML
LINKLIBS = $(XMHTMLLIB) $(LOADLIBES) $(DMALLOCLIB)

# rule to create .o files from .c files 
.c.o:
	$(RM) $@
	$(CC) $(CFLAGS) $(CPPFLAGS) $(XMHTMLINC) $(INCLUDES) -c $<

all: $(EXAMPLES)

# targets to build

simple_html::  ../src/libXmHTML.a simple_html.o
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) simple_html.o $(LINKLIBS)

simple_html2::  ../src/libXmHTML.a simple_html2.o
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) simple_html2.o $(LINKLIBS)

autosize_html::  ../src/libXmHTML.a autosize_html.o
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) autosize_html.o $(LINKLIBS)

forced_html::  ../src/libXmHTML.a forced_html.o
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) forced_html.o $(LINKLIBS)

html::  ../src/libXmHTML.a html.o
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) html.o $(LINKLIBS)

html_browser::  ../src/libXmHTML.a html_browser.o
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) html_browser.o $(LINKLIBS)

.PHONY: ../src/libXmHTML.a 

depend:: $(SRCS) 
	$(MAKEDEPEND) $(XMHTMLINC) $(INCLUDES) $(CPPFLAGS) $(SRCS)

.PHONY: stamp-includes

includes:: stamp-includes

clean::
	$(RM) $(OBJS)  
	$(RM) $(EXAMPLES)

distclean:: clean 
	$(RM) core *.out *.log make.world *.bak *.last *.auto *.rej *.orig
	#$(CP) Makefile.org Makefile

#--------------------------------------------------------------------------
# don't delete anything below this line, makedepend depends on it
#--------------------------------------------------------------------------

=== contrib/Makefile ===

# List of sources
SRCS = swallow.c swallow2.c

# List of object files
OBJS = swallow.o swallow2.o

# Targets to make
EXAMPLES=swallow2

# rule to create .o files from .c files 
.c.o:
	$(RM) $@
	$(CC) $(CFLAGS) $(CPPFLAGS) $(INCLUDES) -c $< -o $@

all: $(EXAMPLES)

# targets to build

swallow::  swallow.o
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) swallow.o $(LOADLIBES)

swallow2::  swallow2.o
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) swallow2.o $(LOADLIBES)

depend:: $(SRCS) 
	$(MAKEDEPEND) $(INCLUDES) $(CPPFLAGS) $(SRCS)

clean::
	$(RM) $(OBJS)  
	$(RM) $(EXAMPLES)

distclean:: clean 
	$(RM) core *.out make.world *.bak *.last *.auto *.rej *.orig
	#$(CP) Makefile.org Makefile

#--------------------------------------------------------------------------
# don't delete anything below this line, makedepend depends on it
#--------------------------------------------------------------------------

=== examples/Makefile ===

# List of sources
SRCS = example_1.c example_2.c example_4.c
MSRCS= visual.c misc.c cache.c menu.c history.c

# List of object files
OBJS = example_1.o example_2.o example_4.o
MOBJS= visual.o misc.o cache.o menu.o history.o

# Targets to make
EXAMPLES=example_1 example_2 example_4

# The XmHTML library
XMHTMLLIB = -L../lib -lXmHTML

# Richard Offer's http client-side library
HTTPLIB   = -L../http -lhttp

# Libraries against which all examples are linked 
LINKLIBS = $(XMHTMLLIB) $(LOADLIBES) $(DMALLOCLIB)

# rule to create .o files from .c files 
.c.o:
	$(RM) $@
	$(CC) $(CFLAGS) $(CPPFLAGS) $(INCLUDES) -c $<

all: $(EXAMPLES)

# targets to build

example_1::  ../src/libXmHTML.a example_1.o
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) example_1.o $(LINKLIBS)

example_2::  ../src/libXmHTML.a example_2.o $(MOBJS)
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) example_2.o $(MOBJS) $(LINKLIBS)

example_4::  ../src/libXmHTML.a example_4.o
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) example_4.o $(LINKLIBS) $(HTTPLIB)

.PHONY: ../src/libXmHTML.a 
.PHONY: stamp-includes

includes:: stamp-includes

depend:: $(SRCS) $(MSRCS)
	$(MAKEDEPEND) $(INCLUDES) $(CPPFLAGS) $(SRCS) $(MSRCS)

clean::
	$(RM) $(OBJS) $(MOBJS) 
	$(RM) $(EXAMPLES)

distclean:: clean 
	$(RM) core *.out *.log make.world *.bak *.last *.auto *.rej *.orig
	#$(CP) Makefile.org Makefile

#--------------------------------------------------------------------------
# don't delete anything below this line, makedepend depends on it
#--------------------------------------------------------------------------

=== http/Makefile ===
#
# lint configuration. I use lclint.
#

LIBRARY=libhttp.a
SHAREDLIB=libhttp.so.0
SONAME=libhttp.so.0

# List of source, object and header files 
SRCS=HTTP.c cookie.c

OBJS=HTTP.o cookie.o

HEADERS=HTTP.h HTTPP.h
 
# Targets to make
TARGET_STATIC=$(LIBRARY)
TARGET_SHARED=$(SHAREDLIB)

# Subdirectories to visit
SUBDIRS=

# rule to create .o files from .c files 
.c.o:
	$(RM) $@
	$(CC) $(CFLAGS) $(CPPFLAGS) $(INCLUDES) -c $<

all: $(TARGET_STATIC) $(TARGET_SHARED)

# targets to build

$(TARGET_STATIC):: $(OBJS)  
	$(RM) $@ \ 
	$(AR) $@ $(OBJS)  
	$(RANLIB) $@

$(TARGET_SHARED):: $(OBJS)  
	$(RM) $@ ; \
	$(CC) $(LDFLAGS) -o $@ -shared -Wl,-soname,$(SONAME) $(OBJS) $(LOADLIBES)

stamp-includes:
	@if [ -d ../include ]; then set +x; \
	else (set -x; mkdir ../include); fi
	@if [ -d ../include/XmHTML ]; then set +x; \
	else (set -x; mkdir ../include/XmHTML); fi
	@(set -x; cd ../include/XmHTML; for i in $(HEADERS); do \
		$(RM) $$i; \
		$(LN) ../../http/$$i .; \
	done)
	touch $@

includes:: stamp-includes

depend:: $(SRCS) 
	$(MAKEDEPEND) $(INCLUDES) $(CPPFLAGS) $(SRCS)

clean::
	$(RM) $(OBJS)
	$(RM) $(TARGET_STATIC) $(TARGET_SHARED)

distclean:: clean 
	$(RM) core *.out *.log make.world *.bak *.last *.auto *.rej *.orig
	$(RM) *.lh *.lcs *.lint stamp-includes
	#$(CP) Makefile.org Makefile

realclean:: distclean

#--------------------------------------------------------------------------
# don't delete anything below this line, makedepend depends on it
#--------------------------------------------------------------------------

=== lib/Makefile ===
##############################################################################
#                                                                            #
# Makefile.motif: libXmHTML, Motif version                                   #
# Adjust at will                                                             #
#                                                                            #
##############################################################################
#                                                                            #
# (C)Copyright 1995-1997 Ripley Software Development                         #
# All Rights Reserved                                                        #
#                                                                            #
# This file is part of the XmHTML Widget Library.                            #
#                                                                            #
# This library is free software; you can redistribute it and/or              #
# modify it under the terms of the GNU Library General Public                #
# License as published by the Free Software Foundation; either               #
# version 2 of the License, or (at your option) any later version.           #
#                                                                            #
# This library is distributed in the hope that it will be useful,            #
# but WITHOUT ANY WARRANTY; without even the implied warranty of             #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          #
# Library General Public License for more details.                           #
#                                                                            #
# You should have received a copy of the GNU Library General Public          #
# License along with this library; if not, write to the Free                 #
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         #
##############################################################################
#
LIBRARY=libXmHTML.a
SHAREDLIB=libXmHTML.so.$(ARCHIVE)

# Targets to make
TARGET_STATIC=$(LIBRARY)
TARGET_SHARED=$(SHAREDLIB)

# Subdirectories to visit
SUBDIRS= common $(TOOLKIT)

# Target rules
all:: $(TARGET_STATIC) $(TARGET_SHARED)

# Separate rules for all targets 
$(TOOLKIT):: 
	@(set -x; cd $(TOOLKIT); $(MAKE) all $(pass_flags) )

common::
	@(set -x; cd common; $(MAKE) all $(pass_flags) )

$(TARGET_STATIC):: common $(TOOLKIT) 
	$(RM) $@ \ 
	$(AR) $@ common/*.o $(TOOLKIT)/*.o
	$(RANLIB) $@

$(TARGET_SHARED):: common $(TOOLKIT) 
	$(RM) $@ ; \
	$(CC) $(LDFLAGS) -o $@ -shared -Wl,-soname,$(SONAME) common/*.o $(TOOLKIT)/*.o $(LOADLIBES)
	
depend:: 
	@( for dir in $(SUBDIRS) ; do \
		(set -x ; cd $$dir ; $(MAKE) depend $(pass_flags)) ; \
	done)

clean:: 
	@( for dir in $(SUBDIRS) ; do \
		(set -x ; cd $$dir ; $(MAKE) clean $(pass_flags) ) ; \
	done)
	$(RM) $(TARGET_STATIC) $(TARGET_SHARED)

distclean:: 
	@( for dir in $(SUBDIRS) ; do \
		(set -x ; cd $$dir ; $(MAKE) distclean $(pass_flags) ) ; \
	done)
	$(RM) $(TARGET_STATIC) $(TARGET_SHARED)
	$(RM) core *.out *.log make.world *.bak *.last *.auto *.rej *.orig
	#$(CP) Makefile.org Makefile

=== tools/Makefile ===
##############################################################################
#                                                                            #
# Makefile.org: default XmHTML tools makefile.                               #
# Adjust at will                                                             #
#                                                                            #
##############################################################################
#                                                                            #
# (C)Copyright 1995-1997 Ripley Software Development                         #
# All Rights Reserved                                                        #
#                                                                            #
# This file is part of the XmHTML Widget Library.                            #
#                                                                            #
# This library is free software; you can redistribute it and/or              #
# modify it under the terms of the GNU Library General Public                #
# License as published by the Free Software Foundation; either               #
# version 2 of the License, or (at your option) any later version.           #
#                                                                            #
# This library is distributed in the hope that it will be useful,            #
# but WITHOUT ANY WARRANTY; without even the implied warranty of             #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          #
# Library General Public License for more details.                           #
#                                                                            #
# You should have received a copy of the GNU Library General Public          #
# License along with this library; if not, write to the Free                 #
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         #
##############################################################################

# List of sources
SRCS = GetRepTypes.c WidgetSize.c gifinfo.c ImBuffer.c gif2gzf.c \
	httpget.c miniparse.c mkStrings.c ../lib/common/parse.c ../lib/common/LZWStream.c

# List of object files
OBJS = GetRepTypes.o WidgetSize.o gifinfo.o ImBuffer.o gif2gzf.o \
	httpget.o miniparse.o parse.o LZWStream.o mkStrings.o

# Targets to make
TARGETS = reptype wsize gifinfo HTMLparse gif2gzf httpget mkStrings strings

# rule to create .o files from .c files 
.c.o:
	$(RM) $@
	$(CC) $(INCLUDES) $(CFLAGS) $(CPPFLAGS) -c $<

#
# Special object rules
#

#
# gif2gzf needs to know where zlib lives
#
gif2gzf.o: gif2gzf.c
	$(RM) $@
	$(CC) -c $(INCLUDES) $(CFLAGS) $(CPPFLAGS) $(ZLIBINC) $*.c

#
# LZWStream compiled for standalone usage
#
LZWStream.o: ../lib/common/LZWStream.c
	$(RM) $@
	$(CC) -c $(INCLUDES) $(CFLAGS) $(CPPFLAGS) -DNO_XmHTML ../lib/common/LZWStream.c

#
# XmHTML HTML Parser compiled for standalone usage
#
parse.o: ../lib/common/parse.c
	$(RM) $@
	$(CC) -c $(INCLUDES) $(CFLAGS) $(CPPFLAGS) -DMINIPARSE ../lib/common/parse.c

#
# All Targets
#

all: $(TARGETS)

# targets to build

reptype::  GetRepTypes.o
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) GetRepTypes.o $(LOADLIBES)

wsize::  WidgetSize.o
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) WidgetSize.o

gifinfo::  gifinfo.o ImBuffer.o
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) gifinfo.o ImBuffer.o

httpget::  httpget.o
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) httpget.o -L../http -lhttp $(DMALLOCLIB)

mkStrings::  mkStrings.o
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) mkStrings.o

# gif to gzf converter
gif2gzf:: gif2gzf.o LZWStream.o ImBuffer.o
	$(RM) $@ \ 
	$(CC) -o $@ $(LDFLAGS) gif2gzf.o LZWStream.o ImBuffer.o $(ZLIBLIB)

# stand alone parser
HTMLparse:: parse.o miniparse.o
	$(RM) $@
	$(CC) -o $@ $(LDFLAGS) parse.o miniparse.o

depend:: $(SRCS) 
	$(MAKEDEPEND) $(INCLUDES) $(CPPFLAGS) -DMINIPARSE -DNO_XmHTML $(SRCS)

clean::
	$(RM) $(OBJS)  
	$(RM) $(TARGETS)

distclean:: clean 
	$(RM) core *.out *.log make.world *.bak *.last *.auto *.rej *.orig
	#$(CP) Makefile.org Makefile


#Generated headers by mkStrings:
#Generate the resource & warning string tables.
strings: mkStrings strings.lst warnings.lst
	./mkStrings XmHTML -c < strings.lst > ../lib/Motif/strings.c
	./mkStrings XmHTML -h < strings.lst > ../include/XmHTML/HTMLStrings.h
	./mkStrings XmHTML -c -w < warnings.lst > ../lib/Motif/warnings.c
	./mkStrings XmHTML -h -w < warnings.lst > ../include/common/HTMLWarnings.h
	touch $@


#--------------------------------------------------------------------------
# don't delete anything below this line, makedepend depends on it
#--------------------------------------------------------------------------

=== lib/Motif/Makefile ===
##############################################################################
#                                                                            #
# Makefile.org: libXmHTML, Motif version                                     #
# Adjust at will                                                             #
#                                                                            #
##############################################################################
#                                                                            #
# (C)Copyright 1995-1997 Ripley Software Development                         #
# All Rights Reserved                                                        #
#                                                                            #
# This file is part of the XmHTML Widget Library.                            #
#                                                                            #
# This library is free software; you can redistribute it and/or              #
# modify it under the terms of the GNU Library General Public                #
# License as published by the Free Software Foundation; either               #
# version 2 of the License, or (at your option) any later version.           #
#                                                                            #
# This library is distributed in the hope that it will be useful,            #
# but WITHOUT ANY WARRANTY; without even the implied warranty of             #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          #
# Library General Public License for more details.                           #
#                                                                            #
# You should have received a copy of the GNU Library General Public          #
# License along with this library; if not, write to the Free                 #
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         #
##############################################################################
#

# List of source and object files 
MOTIFSRCS= motif.c XmHTML.c output.c XmImage.c plc.c frames.c textsel.c \
	forms.c XCC.c Balloon.c warnings.c strings.c

MOTIFOBJS= motif.o XmHTML.o output.o XmImage.o plc.o frames.o textsel.o \
	forms.o XCC.o Balloon.o warnings.o strings.o

# Comment these out if you don't want to include the debug routines.
# or define NDEBUG in the toplevel Makefile.
DEBSRCS= debug_menu.c
DEBOBJS= debug_menu.o

SRCS = $(MOTIFSRCS) $(DEBSRCS)
OBJS = $(MOTIFOBJS) $(DEBOBJS)

# Target to make
TARGET=$(OBJS)

# Subdirectories to visit
SUBDIRS=

# rule to create .o files from .c files 
.c.o:
	$(RM) $@
	$(CC) $(CFLAGS) -DVERSION=$(VERSION) $(CPPFLAGS) $(INCLUDES) -c $<

# targets to build
all: $(TARGET)

depend:: $(SRCS) 
	$(MAKEDEPEND) $(INCLUDES) $(CPPFLAGS) $(SRCS)

clean::
	$(RM) $(OBJS)

distclean:: clean 
	$(RM) core *.out *.log make.world *.bak *.last *.auto *.rej *.orig
	$(RM) *.lh *.lcs *.lint stamp-includes
	#$(CP) Makefile.org Makefile

#--------------------------------------------------------------------------
# don't delete anything below this line, makedepend depends on it
#--------------------------------------------------------------------------

=== lib/common/Makefile ===
##############################################################################
#                                                                            #
# Makefile.org: libXmHTML, display independent code                          #
# Adjust at will                                                             #
#                                                                            #
##############################################################################
#                                                                            #
# (C)Copyright 1995-1997 Ripley Software Development                         #
# All Rights Reserved                                                        #
#                                                                            #
# This file is part of the XmHTML Widget Library.                            #
#                                                                            #
# This library is free software; you can redistribute it and/or              #
# modify it under the terms of the GNU Library General Public                #
# License as published by the Free Software Foundation; either               #
# version 2 of the License, or (at your option) any later version.           #
#                                                                            #
# This library is distributed in the hope that it will be useful,            #
# but WITHOUT ANY WARRANTY; without even the implied warranty of             #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          #
# Library General Public License for more details.                           #
#                                                                            #
# You should have received a copy of the GNU Library General Public          #
# License along with this library; if not, write to the Free                 #
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         #
##############################################################################
#

# List of source and object files 
COMMONSRCS= events.c hash.c stack.c format.c fonts.c paint.c readXPM.c \
	readJPEGplc.c quantize.c colors.c private.c readBitmap.c public.c \
	readPNG.c readGIFplc.c readGIF.c error.c callbacks.c StringUtil.c \
	images.c readFLG.c readJPEG.c parse.c map.c layout.c LZWStream.c \
	psoutput.c

COMMONOBJS= events.o hash.o stack.o format.o fonts.o paint.o readXPM.o \
	readJPEGplc.o quantize.o colors.o private.o readBitmap.o public.o \
	readPNG.o readGIFplc.o readGIF.o error.o callbacks.o StringUtil.o \
	images.o readFLG.o readJPEG.o parse.o map.o layout.o LZWStream.o \
	psoutput.o

# Comment these out if you don't want to include the debug routines.
# or define NDEBUG in the toplevel Makefile.
DEBSRCS= debug.c
DEBOBJS= debug.o

SRCS = $(COMMONSRCS) $(DEBSRCS)
OBJS = $(COMMONOBJS) $(DEBOBJS)

# Target to make
TARGET=$(OBJS)

# Subdirectories to visit
SUBDIRS=

# rule to create .o files from .c files 
.c.o:
	$(RM) $@
	$(CC) $(CFLAGS) -DVERSION=$(VERSION) $(CPPFLAGS) $(INCLUDES) -c $<

# targets to build
all: $(TARGET)

depend:: $(SRCS) 
	$(MAKEDEPEND) $(INCLUDES) $(CPPFLAGS) $(SRCS)

clean::
	$(RM) $(OBJS)

distclean:: clean 
	$(RM) core *.out *.log make.world *.bak *.last *.auto *.rej *.orig
	$(RM) *.lh *.lcs *.lint stamp-includes
	#$(CP) Makefile.org Makefile

#--------------------------------------------------------------------------
# don't delete anything below this line, makedepend depends on it
#--------------------------------------------------------------------------

=== lib/gtk/Makefile ===
##############################################################################
#                                                                            #
# Makefile.org: libXmHTML, Gtk version                                       #
# Adjust at will                                                             #
#                                                                            #
##############################################################################
#                                                                            #
# (C)Copyright 1995-1997 Ripley Software Development                         #
# All Rights Reserved                                                        #
#                                                                            #
# This file is part of the XmHTML Widget Library.                            #
#                                                                            #
# This library is free software; you can redistribute it and/or              #
# modify it under the terms of the GNU Library General Public                #
# License as published by the Free Software Foundation; either               #
# version 2 of the License, or (at your option) any later version.           #
#                                                                            #
# This library is distributed in the hope that it will be useful,            #
# but WITHOUT ANY WARRANTY; without even the implied warranty of             #
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU          #
# Library General Public License for more details.                           #
#                                                                            #
# You should have received a copy of the GNU Library General Public          #
# License along with this library; if not, write to the Free                 #
# Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.         #
##############################################################################
#

# List of source and object files 
GTKSRCS= gtk.c XmHTML.c textsel.c plc.c output.c frames.c forms.c XmImage.c \
	warnings.c

GTKOBJS= gtk.o XmHTML.o textsel.o plc.o output.o frames.o forms.o XmImage.o \
	warnings.o

# Comment these out if you don't want to include the debug routines.
# or define NDEBUG in the toplevel Makefile.
DEBSRCS= debug_menu.c
DEBOBJS= debug_menu.o

SRCS = $(GTKSRCS) $(DEBSRCS)
OBJS = $(GTKOBJS) $(DEBOBJS)

# Target to make
TARGET=$(OBJS)

# Subdirectories to visit
SUBDIRS=

# rule to create .o files from .c files 
.c.o:
	$(RM) $@
	$(CC) $(CFLAGS) -DVERSION=$(VERSION) $(CPPFLAGS) $(INCLUDES) -c $<

# targets to build
all: $(TARGET)

depend:: $(SRCS) 
	$(MAKEDEPEND) $(INCLUDES) $(CPPFLAGS) $(SRCS)

clean::
	$(RM) $(OBJS)

distclean:: clean 
	$(RM) core *.out *.log make.world *.bak *.last *.auto *.rej *.orig
	$(RM) *.lh *.lcs *.lint stamp-includes
	#$(CP) Makefile.org Makefile

#--------------------------------------------------------------------------
# don't delete anything below this line, makedepend depends on it
#--------------------------------------------------------------------------

=== debian/changelog ===
xmhtml (1.1.10-4.1build2) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 15:48:14 +1100

xmhtml (1.1.10-4.1build1) noble; urgency=medium

  * No-change rebuild against libxt6t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 09 Mar 2024 01:02:19 +0000

xmhtml (1.1.10-4.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1063278

 -- Steve Langasek <vorlon@debian.org>  Thu, 29 Feb 2024 07:38:46 +0000

xmhtml (1.1.10-4) unstable; urgency=medium

  * Switch to debhelper 13
  * Set Rules-Requires-Root: no
  * Drop dh-exec, not needed with debhelper 13
  * Do not link with -Wl,--as-needed, it is now the default
  * Add Build-Depends-Package to symbols file
  * Use secure URIs in debian/watch and upstream Homepage
  * Drop trailing whitespace from debian/changelog
  * Drop obsolete Breaks/Replaces
  * Bump Standards-Version to 4.5.0, no changes

 -- Graham Inggs <ginggs@debian.org>  Sat, 04 Jul 2020 09:11:41 +0000

xmhtml (1.1.10-3) unstable; urgency=medium

  * Update Vcs-* URIs for move to salsa.debian.org
  * Turn debhelper up to 11
  * Drop override_dh_strip, ddeb migration is complete
  * Drop trailing whitespace from debian/changelog
  * Update debian/copyright
  * Enable all hardening options
  * Bump Standards-Version to 4.1.4, no changes

 -- Graham Inggs <ginggs@debian.org>  Thu, 03 May 2018 15:02:32 +0000

xmhtml (1.1.10-2) unstable; urgency=medium

  * Migrate from libxmhtml1.1-dbg to ddebs, bump debhelper build-dependency.
  * Use secure URIs for VCS fields.
  * Bump Standards-Version to 3.9.7, no changes needed.
  * Remove transitional package xmhtml1-dev.
  * Sort object files to make build reproducible,
    thanks Reiner Herrmann for testing my patch.

 -- Graham Inggs <ginggs@debian.org>  Mon, 04 Apr 2016 20:07:56 +0200

xmhtml (1.1.10-1) unstable; urgency=medium

  * New upstream release.
  * Update my email address.
  * Drop fix-endless-event-loop.patch included upstream.
  * Update debian/copyright.
  * Bump Standards-Version to 3.9.6, no further changes.

 -- Graham Inggs <ginggs@debian.org>  Wed, 04 Nov 2015 15:33:34 +0200

=== debian/control ===
Source: xmhtml
Section: x11
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Graham Inggs <ginggs@debian.org>
Uploaders: Paul Gevers <elbrus@debian.org>
Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13),
               libfontconfig1-dev,
               libjpeg-dev,
               libmotif-dev,
               libpng-dev,
               libxft-dev,
               libxmu-dev,
               libxpm-dev
Standards-Version: 4.5.0
Rules-Requires-Root: no
Homepage: https://sourceforge.net/projects/xmhtml/
Vcs-Browser: https://salsa.debian.org/debian/xmhtml
Vcs-Git: https://salsa.debian.org/debian/xmhtml.git

Package: libxmhtml-dev
Architecture: any
Multi-Arch: same
Depends: libc6-dev, libmotif-dev, libxmhtml1.1t64 (= ${binary:Version}), ${misc:Depends}
Section: libdevel
Description: Motif widget for displaying HTML 3.2 (development files)
 XmHTML is a high performance Motif Widget capable of displaying HTML
 3.2 confirming text.  Graphics support, lesstif compatibility and
 extensive documentation are amongst its many features.
 .
 This is the development kit, containing static libraries and header files
 necessary to build programs that use XmHTML. The runtime library is
 provided by the libxmhtml package.

Package: libxmhtml1.1t64
Provides: ${t64:Provides}
Replaces: libxmhtml1.1
Breaks: libxmhtml1.1 (<< ${source:Version})
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Pre-Depends: ${misc:Pre-Depends}
Section: libs
Description: Motif widget for displaying HTML 3.2 (library)
 XmHTML is a high performance Motif Widget capable of displaying HTML
 3.2 confirming text.  Graphics support, lesstif compatibility and
 extensive documentation are amongst its many features.
 .
 This package provides the runtime shared library. The libxmhtml-dev
 package provides the header files, and the static library.

=== debian/rules ===
#!/usr/bin/make -f

export version=$(shell expr `pwd` : '.*-\([0-9.]*\)')
export version_major=$(shell expr `pwd` : '.*-\([0-9].[0-9]*\)[0-9]*')
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_autoreconf:

override_dh_auto_build:
	dh_auto_build -- lib LDFLAGS="$(LDFLAGS)" CFLAGS="$(CFLAGS) -fPIC $(CPPFLAGS)"

=== debian/watch ===
version=3
https://qa.debian.org/watch/sf.php/xmhtml/XmHTML-(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
